# uuid

Larky module containing functions working with uuid.

UUID objects (universally unique identifiers) according to RFC 4122. This module provides immutable UUID objects (class UUID) and the functions uuid1(), uuid3(), uuid4(), uuid5() for generating version 1, 3, 4, and 5 UUIDs as specified in RFC 4122. If all you want is a unique ID, you should probably call uuid1() or uuid4(). Note that uuid1() may compromise privacy since it creates a UUID containing the computer’s network address. uuid4() creates a random UUID.

Examples:

```python
import uuid
# make a UUID based on the host ID and current time
uuid.uuid1()    
UUID('a8098c1a-f86e-11da-bd1a-00112444be1e')
# make a UUID using an MD5 hash of a namespace UUID and a name
uuid.uuid3(uuid.NAMESPACE_DNS, 'python.org')
UUID('6fa459ea-ee8a-3ca4-894e-db77e160355e')
# make a random UUID
uuid.uuid4()    
UUID('16fd2706-8baf-433b-82eb-8c7fada847da')
# make a UUID using a SHA-1 hash of a namespace UUID and a name
uuid.uuid5(uuid.NAMESPACE_DNS, 'python.org')
UUID('886313e1-3b8a-5372-9b90-0c9aee199e5d')
# make a UUID from a string of hex digits (braces and hyphens ignored)
x = uuid.UUID('{00010203-0405-0607-0809-0a0b0c0d0e0f}')
# convert a UUID to a string of hex digits in standard form
str(x)
'00010203-0405-0607-0809-0a0b0c0d0e0f'
# get the raw 16 bytes of the UUID
x.bytes
b'
’
# make a UUID from a 16-byte string uuid.UUID(bytes=x.bytes) UUID(‘00010203-0405-0607-0809-0a0b0c0d0e0f’)
```

Similar to [uuid](https://docs.python.org/3/library/uuid.html).

## uuid.UUID(hex=None, bytes=None, bytes\_le=None, fields=None, int=None, version=None, is\_safe=None)

Instances of the UUID class represent UUIDs as specified in RFC 4122. UUID objects are immutable, hashable, and usable as dictionary keys. Converting a UUID to a string with str() yields something in the form ‘12345678-1234-1234-1234-123456789abc’. The UUID constructor accepts five possible forms: a similar string of hexadecimal digits, or a tuple of six integer fields (with 32-bit, 16-bit, 16-bit, 8-bit, 8-bit, and 48-bit values respectively) as an argument named ‘fields’, or a string of 16 bytes (with all the integer fields in big-endian order) as an argument named ‘bytes’, or a string of 16 bytes (with the first three fields in little-endian order) as an argument named ‘bytes\_le’, or a single 128-bit integer as an argument named ‘int’.

Examples:

```python
UUID('{12345678-1234-5678-1234-567812345678}')
UUID('12345678123456781234567812345678')
UUID('urn:uuid:12345678-1234-5678-1234-567812345678')
UUID(bytes=' 4Vx'*4)
UUID(bytes_le='xV4 4 xV' +
...                 ' 4Vx 4Vx')
UUID(fields=(0x12345678, 0x1234, 0x5678, 0x12, 0x34, 0x567812345678))
UUID(int=0x12345678123456781234567812345678)
```

Exactly one of `hex`, `bytes`, `bytes_le`, `fields`, or `int` must be given. The `version` argument is optional; if given, the resulting UUID will have its variant and version set according to RFC 4122, overriding the given `hex`, `bytes`, `bytes_le`, `fields`, or `int`. `is_safe` is an enum exposed as an attribute on the instance.

**Parameters:**

* **bytes** – the UUID as a 16-byte string (containing the six integer fields in big-endian byte order).
* **bytes\_le** – the UUID as a 16-byte string (with time\_low, time\_mid, and time\_hi\_version in little-endian byte order).
* **fields** – a tuple of the six integer fields of the UUID, which are also available as six individual attributes and two derived attributes:

  > * time\_low the first 32 bits of the UUID
  > * time\_mid the next 16 bits of the UUID
  > * time\_hi\_version the next 16 bits of the UUID
  > * clock\_seq\_hi\_variant the next 8 bits of the UUID
  > * clock\_seq\_low the next 8 bits of the UUID
  > * node the last 48 bits of the UUID
  > * time the 60-bit timestamp
  > * clock\_seq the 14-bit sequence number
* **hex** – the UUID as a 32-character hexadecimal string.
* **int** – the UUID as a 128-bit integer.
* **urn** – the UUID as a URN as specified in RFC 4122.
* **variant** – the UUID variant (one of the constants RESERVED\_NCS, RFC\_4122, RESERVED\_MICROSOFT, or RESERVED\_FUTURE).
* **version** – the UUID version number (1 through 5, meaningful only when the variant is RFC\_4122)
* **is\_safe** – an enum indicating whether the UUID has been generated in a way that is safe for multiprocessing applications, via uuid\_generate\_time\_safe(3).

## uuid.uuid4()

Generate a random UUID.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.verygoodsecurity.com/vault/developer-tools/larky/library-api/uuid.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
